<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoValeTransporte extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();
        
        $nrlinhatransp    = $itens['NRLINHATRANSP']   ?? null;
        $nrtipolinhavinc  = $itens['NRTIPOLINHAVINC'] ?? null;
        $nrsentidolinha   = $itens['NRSENTIDOLINHA']  ?? null;
        $qtlinhatarifa    = $itens['QTLINHATARIFA']   ?? null;
        $dsobslinhavinc   = $itens['DSOBSLINHAVINC']   ?? null;
        $cdTipoaltevt     = $itens['CDTIPOALTEVT']   ?? null;
        $dtinilinhavinc   = isset($itens['DTINILINHAVINC']) ? DateUtil::getDataDeString(substr($itens['DTINILINHAVINC'],0,10), DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtfimlinhavinc   = isset($itens['DTFIMLINHAVINC']) ? DateUtil::getDataDeString(substr($itens['DTFIMLINHAVINC'],0,10), DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtaltelinhavinc  = isset($itens['DTALTELINHAVINC']) ? DateUtil::getDataDeString(substr($itens['DTALTELINHAVINC'],0,10), DateUtil::FORMATO_BRASILEIRO, true) : null;
        $nrorg            = Utils::getParamters()->getNrorg();
        $nrvinculom       = $this->getSolicitacao()->getNrvinculom();
        $dsobssolicitacao = $this->getSolicitacao()->getDsobssolicitacao();
        $cdoperador       = Utils::getParamters()->getCdoperador();
        $max_campos = 8;


        if($cdTipoaltevt == 'E') {
            ProcessamentoSolicitacaoUtil::atualizaVabLinhaVinc($nrorg, $nrvinculom, $nrlinhatransp, $dtfimlinhavinc, $dsobslinhavinc, $dtaltelinhavinc, $cdoperador);

            for ($i = 2; $i <= $max_campos; $i++) {
                $campo_linha = "NRLINHATRANSP_" . $i;
                $campo_tipo = "NRTIPOLINHAVINC_" . $i;
                $campo_qt  =  "QTLINHATARIFA_" .$i;
    
                if(isset($itens[$campo_linha]) && isset($itens[$campo_tipo]) && isset($itens[$campo_qt])) {
                    ProcessamentoSolicitacaoUtil::atualizaVabLinhaVinc($nrorg, $nrvinculom, $itens[$campo_linha], $dtfimlinhavinc, $dsobslinhavinc, $dtaltelinhavinc, $cdoperador);
                }
            }

            return;
        }


        $vabLinhavinc = Repositories::VAB_LINHAVINC;
        $vabLinhavinc = new $vabLinhavinc;
        $vabLinhavinc->setNrorg($nrorg);
        $vabLinhavinc->setNrvinculom($nrvinculom);
        $vabLinhavinc->setNrsentidolinha($nrsentidolinha);
        $vabLinhavinc->setQtlinhatarifa($qtlinhatarifa);
        $vabLinhavinc->setDtinilinhavinc($dtinilinhavinc);
        $vabLinhavinc->setDtfimlinhavinc($dtfimlinhavinc);
        $vabLinhavinc->setNrlinhatarifa($nrlinhatransp);
        $vabLinhavinc->setNrtipolinhavinc($nrtipolinhavinc);
        $vabLinhavinc->setDsobslinhavinc($dsobslinhavinc);
        $vabLinhavinc->setDtinclusao(DateUtil::getDataAtual(false));
        $vabLinhavinc->setDtultatu($dtaltelinhavinc);
        $vabLinhavinc->setNrorginclusao($nrorg);
        $vabLinhavinc->setCdoperinclusao($cdoperador);
        $vabLinhavinc->setNrorgultatu($nrorg);
        $vabLinhavinc->setCdoperultatu($cdoperador);
        $vabLinhavinc->setNrlinhavinc(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'VAB_LINHAVINC', 1, 12, true));
        Utils::getEntityManager()->persist($vabLinhavinc);
        Utils::getEntityManager()->flush();

        for ($i = 2; $i <= $max_campos; $i++) {
            $campo_linha = "NRLINHATRANSP_" . $i;
            $campo_tipo = "NRTIPOLINHAVINC_" . $i;
            $campo_qt  =  "QTLINHATARIFA_" .$i;

            if(isset($itens[$campo_linha]) && isset($itens[$campo_tipo]) && isset($itens[$campo_qt])) {

                $vabLinhavinc = Repositories::VAB_LINHAVINC;
                $vabLinhavinc = new $vabLinhavinc;
                $vabLinhavinc->setNrorg($nrorg);
                $vabLinhavinc->setNrvinculom($nrvinculom);
                $vabLinhavinc->setNrsentidolinha($nrsentidolinha);
                $vabLinhavinc->setQtlinhatarifa($itens[$campo_qt]);
                $vabLinhavinc->setDtinilinhavinc($dtinilinhavinc);
                $vabLinhavinc->setDtfimlinhavinc($dtfimlinhavinc);
                $vabLinhavinc->setNrlinhatarifa($itens[$campo_linha]);
                $vabLinhavinc->setNrtipolinhavinc($itens[$campo_tipo]);
                $vabLinhavinc->setDsobslinhavinc($dsobslinhavinc);
                $vabLinhavinc->setDtinclusao(DateUtil::getDataAtual(false));
                $vabLinhavinc->setDtultatu($dtaltelinhavinc);
                $vabLinhavinc->setNrorginclusao($nrorg);
                $vabLinhavinc->setCdoperinclusao($cdoperador);
                $vabLinhavinc->setNrorgultatu($nrorg);
                $vabLinhavinc->setCdoperultatu($cdoperador);
                $vabLinhavinc->setNrlinhavinc(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'VAB_LINHAVINC', 1, 12, true));
                Utils::getEntityManager()->persist($vabLinhavinc);
                Utils::getEntityManager()->flush();

            }
        }

    }
    
    public function rejeitar() {}
}