/* Tabela TIPOOPERANA: Cadastro de Tipo de Operao para gerar anlises na entrada de notas */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela TIPOOPERANA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela TIPOOPERANA,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_QPR_TIPOOPERANA
AFTER DELETE OR INSERT OR UPDATE
ON TIPOOPERANA FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DTOPER       DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN
      IF :OLD.NRSEQTPOPANA IS NOT NULL THEN
         V_DESC := V_DESC || 'NrSeq=' || TO_CHAR(:OLD.NRSEQTPOPANA);
      END IF;

      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' Filial=' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || ' E/S=' || :OLD.IDENTRSAIDOP;
      END IF;

      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TpOper=' || :OLD.CDTIPOOPER;
      END IF;


      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFILIAL||:OLD.IDENTRSAIDOP||:OLD.CDTIPOOPER;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         IF (:OLD.NRSEQTPOPANA <> :NEW.NRSEQTPOPANA)   OR
            (:OLD.CDFILIAL     <> :NEW.CDFILIAL)      OR
            (:OLD.IDENTRSAIDOP <> :NEW.IDENTRSAIDOP)     OR
            (:OLD.CDTIPOOPER   <> :NEW.CDTIPOOPER)    THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDFILIAL||:OLD.IDENTRSAIDOP||:OLD.CDTIPOOPER;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
         END IF;
      ELSE
         
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.IDENTRSAIDOP||:NEW.CDTIPOOPER;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
         
      END IF;
      
      IF NVL(TO_CHAR(:NEW.NRSEQTPOPANA), '!') <> NVL(TO_CHAR(:OLD.NRSEQTPOPANA), '!') THEN
         V_DESC := V_DESC || 'NrSeq=' || TO_CHAR(:NEW.NRSEQTPOPANA);
      END IF;
      
      IF NVL(:NEW.CDFILIAL, '!') <> NVL(:OLD.CDFILIAL, '!') THEN
         V_DESC := V_DESC || ' Filial=' || :NEW.CDFILIAL;
      END IF;

      IF NVL(:NEW.IDENTRSAIDOP, '!') <> NVL(:OLD.IDENTRSAIDOP, '!') THEN
         V_DESC := V_DESC || ' E/S=' || :NEW.IDENTRSAIDOP;
      END IF;

      IF NVL(:NEW.CDTIPOOPER, '!') <> NVL(:OLD.CDTIPOOPER, '!') THEN
         V_DESC := V_DESC || ' TpOper=' || :NEW.CDTIPOOPER;
      END IF;
      
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN

         V_DTOPER := SYSDATE;

         INSERT INTO LOGOPERA
            (NMTABELA,
             DTOPERACAO,
             NMRESPOPER,
             IDTIPOOPER,
             CDPESQITEM,
             DSOPERACAO,
             CDFILLOGOPER,
             DSRDMUSUOPER,
             DSENDUSUOPER,
             DSNMUSUOPER,
             DSMETUSUOPER,
             CDORESPOPER)
         VALUES
            ('TIPOOPERANA',
             V_DTOPER,
             V_USUARIO,
             V_TIPO,
             V_ITPESQ,
             SUBSTR(V_DESC,1,300),
             V_CDFILLOGOPER,
             V_DSSERVERRDM,
             V_DSREMOTEADDR,
             V_DSREMOTEHOST,
             V_DSSERVMETHOD,
             V_DSREMOTEOPER);

      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_QPR_TIPOOPERANA','6.05.XXX'); END;
/

